from PIL import Image

def make_reddish_pixels_transparent(image_path):
    # Open the image
    image = Image.open(image_path)

    # Convert the image to RGBA mode
    image = image.convert("RGBA")

    # Get the pixel data from the image
    pixel_data = image.load()

    # Iterate over each pixel
    for i in range(image.width):
        for j in range(image.height):
            # Get the RGB values of the pixel
            r, g, b, _ = pixel_data[i, j]

            # Check if the pixel is reddish
            if r > g + 10 and r > b + 10:
                # Calculate the transparency based on the redness
                transparency = 255 - r

                # Set the pixel's transparency
                pixel_data[i, j] = (r, g, b, transparency)

    # Save the modified image
    image.save("output.png")

make_reddish_pixels_transparent('Alarm_Clock_Albedo.jpg')
