public class Clock extends GGen {
	GMesh mesh --> this;

	@(0.1, 0.1, 0.1) => mesh.sca;

	PhongMaterial mat;
  FileTexture _texture;

  ObjLoader.load(me.dir() + "assets/models/alarm-clock/source/Alarm Clock.obj") => mesh.geo;
  mat => mesh.mat;

	@((-0.25, 0.25) => Math.random2f, (-0.25, 0.25) => Math.random2f, (-0.25, 0.25) => Math.random2f) => vec3 vrot;
	1 => int mass;
	@(0, 0, 0) => vec3 f;
	@(0, 0, 0) => vec3 a;
	@(0, 0, 0) => vec3 v;
	@(0, 0, 0) => vec3 x;
	0.01 => float mu;

	6.67408 * ((10, -11) => Math.pow) => float G;
	2 * ((10, 26) => Math.pow) => float M;
	3 * ((10, 8) => Math.pow) => float c;
	1 => float t;

	FileTexture ht;
  PhongMaterial hm;

  me.dir() + "assets/models/alarm-clock/textures/hour.png" => ht.path;
  ht => hm.diffuseMap;
  true => hm.transparent;

	GPlane m --> this;
	GPlane h --> this;
	GPlane alarm;

	0.12 => h.posY;
	0.975 => h.posZ;
  hm => h.mat;
  @(0.03, 0.6, 1) => h.sca;
  -Math.PI / 19 => h.rotX;

  0.12 => m.posY;
  0.975 => m.posZ;
  hm => m.mat;
  @(0.03, 1.2, 1) => m.sca;
  -Math.PI / 19 => m.rotX;

  FileTexture at;
  PhongMaterial am;

  me.dir() + "assets/models/alarm-clock/textures/alarm-hand.png" => at.path;
  at => am.diffuseMap;
  true => am.transparent;

  int hr;
  int min;

	float pct;
	-1 => float alarmPct;
	false => int alarmed;

  0.12 => alarm.posY;
  0.975 => alarm.posZ;
  am => alarm.mat;
  @(0.08, 1.2, 1) => alarm.sca;
  -Math.PI / 19 => alarm.rotX;

  GCube cube --> this;
  FlatMaterial cm;
  Material.POLYGON_LINE => cm.polygonMode;
	@(1, 0, 0) => cm.color;
  cm => cube.mat;
  @(0, 0, 0) => cube.sca;
  0.6 => cube.posZ;
  false => int _selected;

  SndBuf buf => ADSR env => NRev rev => dac;
  string filename;

  (50::ms, 0::ms, 1, 50::ms) => env.set;
  0.1 => rev.mix;

  20 => float speed;

  fun void _play() {
    me.dir() + "assets/audio/" + filename => buf.read;
    env.keyOn();
    0.2::second => now;
    env.keyOff();
    500::ms => now;
  }

  fun void alarmTime(int h, int m) {
    h => hr;
		m => min;
    Math.TWO_PI * hr / 12 + Math.TWO_PI * min / (12 * 60) => alarm.rotateZ;
    (hr * 60 + min) / 1440. => alarmPct;
    alarm --> this;
  }

  fun void selected(int s) {
    s => _selected;
    if (s) @(2.5, 2.5, 2.5) => cube.sca;
    else @(0, 0, 0) => cube.sca;
  }

  fun void texture(string path) {
    me.dir() + "assets/models/alarm-clock/textures/" + path => _texture.path;
    _texture => mat.diffuseMap;
  }

// NOTE: https://physics.stackexchange.com/questions/524230/time-dilation-due-to-gravitational-potential
  fun void update(float dt) {
    vrot * dt => rotate;

		f / mass => a;
		a * dt +=> v;
		@(-v.x, -v.y, -v.z) * mu +=> v;
		v * dt +=> x;
		x => pos;

	  ((((posX() - GG.camera().posX(), 2) => Math.pow) + ((posY() - GG.camera().posY(), 2) => Math.pow) + ((posZ() - GG.camera().posZ(), 2) => Math.pow)) => Math.sqrt) => float r;
	  t / (1 - 2 * G * M / (((c, 2) => Math.pow) * r) => Math.sqrt) => float t1;

	  speed * dt / t1 => m.rotateZ;
	  speed * dt / (12 * t1) => h.rotateZ;

		speed * dt / (12 * t1) / Math.TWO_PI / 2 +=> pct;
		1 %=> pct;

		if (pct > alarmPct && alarmPct >= 0 && !alarmed) {
			spork ~ _play();
			true => alarmed;
		} else if (alarmed && pct <= alarmPct) false => alarmed;
  }
}
