global Clocks CLOCKS;

public class KeyboardSelect extends KeyboardInterface {
	1 => device;
	-1 => int selected;

	250 => float f;

	fun void impulse(Clock @ c, vec3 f) {
  	f => c.f;
  	(10 * GG.dt())::second => now;
  	@(0, 0, 0) => c.f;
  }

	fun void callback() {
		if (which == KB.KEY_TAB) {
			if (selected < CLOCKS.cs.size()) false => CLOCKS.cs[selected].selected;
			selected++;
			selected % (CLOCKS.cs.size() + 1) => selected;
			if (selected < CLOCKS.cs.size()) true => CLOCKS.cs[selected].selected;
		} else if (which == KB.KEY_LEFT && selected >= 0 && selected < CLOCKS.cs.size()) {
			spork ~ impulse(CLOCKS.cs[selected], @(-f, 0, 0));
		} else if (which == KB.KEY_RIGHT && selected >= 0 && selected < CLOCKS.cs.size()) {
			spork ~ impulse(CLOCKS.cs[selected], @(f, 0, 0));
		} else if (which == KB.KEY_UP && selected >= 0 && selected < CLOCKS.cs.size()) {
			spork ~ impulse(CLOCKS.cs[selected], @(0, f, 0));
		} else if (which == KB.KEY_DOWN && selected >= 0 && selected < CLOCKS.cs.size()) {
			spork ~ impulse(CLOCKS.cs[selected], @(0, -f, 0));
		} else if (which == KB.KEY_EQUAL && selected >= 0 && selected < CLOCKS.cs.size()) {
			spork ~ impulse(CLOCKS.cs[selected], @(0, 0, f));
		} else if (which == KB.KEY_MINUS && selected >= 0 && selected < CLOCKS.cs.size()) {
			spork ~ impulse(CLOCKS.cs[selected], @(0, 0, -f));
		} else if (which == KB.KEY_BACKSPACE && selected >= 0 && selected < CLOCKS.cs.size()) {
			CLOCKS.cs[selected] --< GG.scene();
			selected => CLOCKS.cs.erase;
			CLOCKS.cs.size() => selected;
		}
	}
}

