global SphereGeometry g;

class Star extends GMesh {
	FlatMaterial m;

	g => geo;
	m => mat;

	(0.05, 0.2) => Math.random2f => float scale;
	@(scale, scale, scale) => sca;

	(0.2, 3) => Math.random2f => float speed;

	Math.random2f(0, 2 * Math.PI) => float phase;

	now => time start;
	fun void update(float dt) {
		(1 + ((speed * (now - start) / second + phase) => Math.sin)) / 2 => float shade;
		@(shade, shade, shade) => m.color;
	}
}

class Light extends GPointLight {
	(0.2, 3) => Math.random2f => float speed;
	Math.random2f(0, 2 * Math.PI) => float phase;
	now => time start;
  fun void update(float dt) {
    (1 + ((speed * (now - start) / second + phase) => Math.sin)) / 1.5 => intensity;
  }
}

public class Stars extends GGen {
	Star stars[(300, 500) => Math.random2];
	for (auto @ s : stars) {
		s --> this;
		@((-20, 20) => Math.random2f, (-20, 20) => Math.random2f, (-20, 20) => Math.random2f) => s.pos;
	}

	Light light[12];
	for (auto @ l : light) {
		l --> this;
		@((-20, 20) => Math.random2f, (-20, 20) => Math.random2f, (-20, 20) => Math.random2f) => l.pos;
	}
}
